import { CronosExpression } from './expression';
declare type CronosTaskListeners = {
    'started': () => void;
    'stopped': () => void;
    'run': (timestamp: number) => void;
    'ended': () => void;
};
export declare class CronosTask {
    private _listeners;
    private _timestamp?;
    private _expression;
    constructor(expression: CronosExpression);
    start(): this;
    stop(): this;
    readonly nextRun: Date | undefined;
    readonly isRunning: boolean;
    private _runTask;
    private _updateTimestamp;
    on<K extends keyof CronosTaskListeners>(event: K, listener: CronosTaskListeners[K]): this;
    off<K extends keyof CronosTaskListeners>(event: K, listener: CronosTaskListeners[K]): this;
    private _emit;
}
export {};
